

Declare UserAction(timeout)
Declare joinButtons()



Procedure thread_play(val)
  Repeat
    ForEach beep()
      If Not beep()\mute
        Beep_( beep()\frequency, beep()\duration )
      Else
        Delay( beep()\duration )
      EndIf
      If shutUp
        Break
      EndIf
    Next
  Until shutUp Or Not playAsLoop
  DisableToolBarButton(#Toolbar,#ButtSing,0)
  DisableToolBarButton(#Toolbar,#ButtShut,1)
EndProcedure


Procedure thread_beep(val)
  Beep_( beep_thread_freq, beep_thread_dura )
EndProcedure


Procedure sing(mode)
  DisableToolBarButton(#Toolbar,#ButtSing,1)
  DisableToolBarButton(#Toolbar,#ButtShut,0)
  While WindowEvent() : Wend
  
  first=-1
  If selectedArea_on
    For i=selectedArea_i1 To selectedArea_i2
      If i>=0 And i<=x
        For k=0 To y
          If first=-1 And b(i,k)\toggled
            first=i
          EndIf
          If b(i,k)\toggled
            last=i
          EndIf
        Next
      Else
        Debug "sing() - AOOBE - (first_last_find)"
      EndIf
    Next
  Else; no selection
    For i=0 To x
      For k=0 To y
        If first=-1 And b(i,k)\toggled
          first=i
        EndIf
        If b(i,k)\toggled
          last=i
        EndIf
      Next
    Next
  EndIf
  
  If first=-1 ;no notes to play
    DisableToolBarButton(#Toolbar,#ButtSing,0)
    DisableToolBarButton(#Toolbar,#ButtShut,1)
    ProcedureReturn
  EndIf

  If mode=#sing_sing
    ClearList(beep())
    For i=first To last
      pause=1
      For k=0 To y
        If b(i,k)\toggled
          If b(i,k)\joinL And i>0 And b(i-1,k)\toggled And b(i-1,k)\joinR
            If Not CountList(beep())
              AddElement(beep())
              beep()\frequency = Int( h(y-k) ) 
            EndIf
            beep()\duration + duration
            beep()\mute=0
            pause=0
            Break
          Else
            AddElement( beep() )
            beep()\frequency = Int( h(y-k) ) 
            beep()\duration = duration
            beep()\mute=0
            pause=0
            Break
          EndIf
        EndIf
      Next
      If pause
        AddElement( beep() )
        beep()\duration = duration
        beep()\mute=1
      EndIf
    Next
    shutUp=0
    play_thread_ID=CreateThread( @thread_play(), 0 )
  EndIf

  If mode=#sing_code
    ClearList(code())
    ClearGadgetItemList(#GaEdCode)
    For i=first To last
      pause=1
      For k=0 To y
        If b(i,k)\toggled
          If b(i,k)\joinL And i>0 And b(i-1,k)\toggled And b(i-1,k)\joinR
            If Not CountList(code())
              AddElement(code())
            EndIf
            joinedDuration+duration
            code()="Beep_( "+Str(Int( h(y-k) ))+", "+Str(joinedDuration)+" )"
            pause=0
            Break
          Else
            AddElement(code())
            code()="Beep_( "+Str(Int( h(y-k) ))+", "+Str(duration)+" )"
            joinedDuration=duration
            pause=0
            Break
          EndIf
        EndIf
      Next
      If pause
        AddElement(code())
        code()="Delay("+Str(duration)+")"
      EndIf
    Next
    ForEach code()
      AddGadgetItem(#GaEdCode,-1, code() )
    Next
    HideWindow(#winCode,0)
    SetActiveGadget(#GaEdCode)
    If Not IsThread(play_thread_ID)
      DisableToolBarButton(#Toolbar,#ButtSing,0)
      DisableToolBarButton(#Toolbar,#ButtShut,1)
    EndIf
  EndIf
  
EndProcedure


Procedure redraw(mode)

  If mode & #redraw_ver
    lineX=ver\w*posVer
    If Not moveView
      If lineX<6
        lineX=1
        posVer=0.0
      ElseIf lineX>ver\w-7
        lineX=ver\w-2
        posVer=1.0
      EndIf
    EndIf
    StartDrawing( ImageOutput(ver\img) )
      Box(0, 0, ver\w , ver\h, $aa5544)
      Line(lineX-2, 0, 0, ver\h, $ff5555)
      Line(lineX-1, 0, 0, ver\h, $ff7777)
      Line(lineX,   0, 0, ver\h, $ffbbbb)
      Line(lineX+1, 0, 0, ver\h, $ff7777)
      Line(lineX+2, 0, 0, ver\h, $ff5555)
    StopDrawing()
    SetGadgetState(#GaImgVer, ImageID(ver\img) )
  EndIf

  If mode & #redraw_hor
    lineY=hor\h*posHor
    If Not moveView
      If lineY<6
        lineY=1
        posHor=0.0
      ElseIf lineY>hor\h-7
        lineY=hor\h-2
        posHor=1.0
      EndIf
    EndIf
    StartDrawing( ImageOutput(hor\img) )
      Box(0, 0, hor\w , hor\h, $aa5544)
      Line(0, lineY-2, hor\w, 0, $ff5555)
      Line(0, lineY-1, hor\w, 0, $ff7777)
      Line(0, lineY,   hor\w, 0, $ffbbbb)
      Line(0, lineY+1, hor\w, 0, $ff7777)
      Line(0, lineY+2, hor\w, 0, $ff5555)
    StopDrawing()
    SetGadgetState(#GaImgHor, ImageID(hor\img) )
  EndIf

  clickBeep=-1
  If mode & #redraw_main
    startX=(x*bw + gapsSum + 5 + bw - (main\w-10)) *posVer
    startY=(y*bh + 4*(y/12) + 5 - (main\h-27)) *posHor
    StartDrawing( ImageOutput(main\img) )
      Box(0,0, main\w, main\h, $aa3322)
      If selectedArea_on
        Box(selectedArea_x1-startX,0, selectedArea_x2-selectedArea_x1,main\h, $aa3322+$442222)
        Line(selectedArea_x1-startX,0, 0,main\h, $22ff22)
        Line(selectedArea_x2-startX,0, 0,main\h, $5555ff)
      EndIf
      For i=0 To x
        For k=0 To y
          If b(i,k)\pos\x > startX-10 And b(i,k)\pos\x < startX+main\w+10    And b(i,k)\pos\y > startY-10 And b(i,k)\pos\y < startY+main\h+10
            If mode & #redraw_main_leftClick
              If (mouseImgX)>=(b(i,k)\pos\x-gaps(i)-startX) And (mouseImgX)<(b(i,k)\pos\x-startX+bw) And (mouseImgY)>=(b(i,k)\pos\y-startY) And (mouseImgY)<(b(i,k)\pos\y-startY+bh)
                mouseIndexOld\x=mouseIndexNew\x
                mouseIndexOld\y=mouseIndexNew\y
                mouseIndexNew\x=i
                mouseIndexNew\y=k
                ;mouseIndexDeltaX=mouseIndexNew\x-mouseIndexOld\x
                mouseIndexDeltaY=mouseIndexNew\Y-mouseIndexOld\Y
                If GetAsyncKeyState_(#VK_SHIFT) And GetAsyncKeyState_(#VK_SHIFT)
                  selectedArea_on=1
                  SetToolBarButtonState(#Toolbar,#ButtSelection,1)
                  selectedArea_i1=i
                  selectedArea_x1=b(i,k)\pos\x -1
                  If selectedArea_i1>selectedArea_i2
                    selectedArea_i2=i
                    selectedArea_x2=b(i,k)\pos\x +bw -1
                  EndIf
                Else
                  For xyz=0 To y
                    b(i,xyz)\toggled=0
                    b(i,xyz)\joinL=0
                    b(i,xyz)\joinR=0
                  Next
                  b(i,k)\toggled=1
                  If dragJoinIndexStart=-1
                    dragJoinIndexStart=i
                    dragJoinIndexEnd=i
                    ;buttonWasUp=1
                  Else
                    If mouseIndexDeltaY
                      joinButtons()
                      ;dragJoinIndexStart=-1
                      dragJoinIndexStart=i
                      dragJoinIndexEnd=i
                    ElseIf i<dragJoinIndexStart
                      dragJoinIndexStart=i
                    ElseIf i>dragJoinIndexEnd
                      dragJoinIndexEnd=i
                    EndIf
                  EndIf
                  joinButtons()
                  clickBeep=Int( h(y-k) )
                EndIf
              EndIf
            ElseIf mode & #redraw_main_rightClick
              If (mouseImgX)>=(b(i,k)\pos\x-gaps(i)-startX) And (mouseImgX)<(b(i,k)\pos\x-startX+bw) And (mouseImgY)>=(b(i,k)\pos\y-startY) And (mouseImgY)<(b(i,k)\pos\y-startY+bh)
                ;mouseIndexOld\x=mouseIndexNew\x
                ;mouseIndexOld\y=mouseIndexNew\y
                ;mouseIndexNew\x=i
                ;mouseIndexNew\y=k
                If GetAsyncKeyState_(#VK_SHIFT) And GetAsyncKeyState_(#VK_SHIFT)
                  selectedArea_on=1
                  SetToolBarButtonState(#Toolbar,#ButtSelection,1)
                  selectedArea_i2=i
                  selectedArea_x2=b(i,k)\pos\x +bw -1
                  If selectedArea_i1>selectedArea_i2
                    selectedArea_i1=i
                    selectedArea_x1=b(i,k)\pos\x -1
                  EndIf
                ElseIf GetAsyncKeyState_(#VK_LCONTROL) & 1<<15
                  showMouseMenu=1
                  ppm_i=i
                Else
                  For xyz=0 To y
                    b(i,xyz)\toggled=0
                    b(i,xyz)\joinL=0
                    b(i,xyz)\joinR=0
                  Next
                  If i>0
                    For xyz=0 To y
                      b(i-1,xyz)\joinR=0
                    Next
                  EndIf
                  If i<x
                    For xyz=0 To y
                      b(i+1,xyz)\joinL=0
                    Next
                  EndIf
                  clickBeep=Int( h(y-k) )
                EndIf
              EndIf
            EndIf
            If b(i,k)\toggled
              If b(i,k)\joinL And b(i,k)\joinR
                DrawImage( img02_LRhnd, b(i,k)\pos\x-startX-4, b(i,k)\pos\y-startY )
              ElseIf b(i,k)\joinL
                DrawImage( img02_Lhnd, b(i,k)\pos\x-startX-4, b(i,k)\pos\y-startY )
              ElseIf b(i,k)\joinR
                DrawImage( img02_Rhnd, b(i,k)\pos\x-startX, b(i,k)\pos\y-startY )
              Else
                DrawImage( img02hnd, b(i,k)\pos\x-startX, b(i,k)\pos\y-startY )
              EndIf
            Else
              DrawImage( img01hnd, b(i,k)\pos\x-startX, b(i,k)\pos\y-startY )
            EndIf
          Else
            
          EndIf
        Next
      Next
    StopDrawing()
    SetGadgetState(#GaImg00,ImageID(main\img))
    Delay(20)
  EndIf
  
  If clickBeep<>-1  ;And  ( buttonWasUp Or mouseIndexNew\x<>mouseIndexOld\x Or mouseIndexNew\y<>mouseIndexOld\y)
    ;buttonWasUp=0
;     If IsThread(beep_thread_ID)
;       KillThread(beep_thread_ID)
;     EndIf
;     beep_thread_freq=clickBeep
;     beep_thread_dura=duration
;     beep_thread_ID=CreateThread( @thread_beep(), 0 )
    If Not IsThread(beep_thread_ID)
      beep_thread_freq=clickBeep
      beep_thread_dura=duration
      beep_thread_ID=CreateThread( @thread_beep(), 0 )
    EndIf
  EndIf
  
EndProcedure


Procedure ResizeWin()
  If WindowWidth(#winMain)<200
    ResizeWindow(#winMain, #PB_Ignore,#PB_Ignore, 200,#PB_Ignore)
  EndIf
  If WindowHeight(#winMain)<100
    ResizeWindow(#winMain, #PB_Ignore,#PB_Ignore, #PB_Ignore,100)
  EndIf
  hor\x=WindowWidth(#winMain)-hor\w-5
  hor\h=WindowHeight(#winMain)-hor\y-5
  ResizeGadget(#GaImgHor, hor\x, #PB_Ignore, #PB_Ignore, hor\h)
  ResizeImage(hor\img, hor\w, hor\h, #PB_Image_Raw)
  ;SetGadgetState(#GaImgHor, ImageID(hor\img) )

  ver\w=WindowWidth(#winMain)-ver\x-hor\w-5-5
  ResizeGadget(#GaImgVer, #PB_Ignore, #PB_Ignore, ver\w, #PB_Ignore)
  ResizeImage(ver\img, ver\w, ver\h, #PB_Image_Raw)
  ;SetGadgetState(#GaImgVer, ImageID(ver\img) )

  main\w=WindowWidth(#winMain)-main\x-hor\w-5-5
  main\h=WindowHeight(#winMain)-main\y-5
  ResizeGadget(#GaImg00, #PB_Ignore, #PB_Ignore, main\w, main\h)
  ResizeImage(main\img, main\w, main\h, #PB_Image_Raw)
  ;SetGadgetState(#GaImg00, ImageID(main\img) )
EndProcedure


Procedure getGaps()
  ; gaps(i) contains the gap between b(i,k) and b(i-1,k)
  gapsSum=0
  For i=0 To x
    gaps(i)=0
    If Not i%smallBar
      gaps(i)+2
    EndIf
    If Not i%(smallBar*largeBar)
      gaps(i)+4
    EndIf
    gapsSum+gaps(i)
  Next
EndProcedure


Procedure getButtonPostions()
  gap=0
  For i=0 To x
    gap+gaps(i)
    xPos= (i*bw + gap + 5)
    For k=0 To y
      yPos= k*bh + 4*(k/12) + 10
      b(i,k)\pos\x=xPos
      b(i,k)\pos\y=yPos
    Next
  Next
EndProcedure


Procedure setEndingGaps()
  For i=x To 0 Step -1
    If gaps(i)=6 ; 4+2
      lastBigGap=i
      Break
    EndIf
  Next
  gapsSum=0
  For i=0 To x
    If i>=lastBigGap
      gaps(i)=0
      If Not (i-lastBigGap)%smallBar
        gaps(i)+2
      EndIf
      If Not (i-lastBigGap)%(smallBar*largeBar)
        gaps(i)+4
      EndIf
    EndIf
    gapsSum+gaps(i)
  Next
EndProcedure


Procedure joinButtons()
  If dragJoinIndexStart>-1 ;And ( dragJoinIndexEnd <> dragJoinIndexStart )

;     If dragJoinIndexStart > dragJoinIndexEnd
;       Swap dragJoinIndexStart, dragJoinIndexEnd
;     EndIf
    
    If dragJoinIndexStart>0
      For k=0 To y
        b(dragJoinIndexStart-1,k)\joinR=0
      Next
    EndIf
    
    For k=0 To y
      b(dragJoinIndexStart,k)\joinL=0
    Next
    
    For i=dragJoinIndexStart To dragJoinIndexEnd-1
      For k=0 To y
        If b(i,k)\toggled And b(i+1,k)\toggled
          b(i,k)\joinR=1
          b(i+1,k)\joinL=1
          Break
        EndIf
      Next
    Next
    
    For k=0 To y
      b(dragJoinIndexEnd,k)\joinR=0
    Next
    
    If dragJoinIndexEnd<x
      For k=0 To y
        b(dragJoinIndexEnd+1,k)\joinL=0
      Next
    EndIf
    
  EndIf
EndProcedure


Procedure new()
  Dim b.bS(x,y)
  Dim gaps.l(x)
  getGaps()
  getButtonPostions()
  
  ;+++++++++++++++ make copy-data compatible
  Protected Dim temp_bCopy.bS(xPrevious,y)
  Protected Dim temp_gapsCopy.l(xPrevious)
  CopyMemory( bCopy(), temp_bCopy(), (xPrevious+1)*(y+1)*SizeOf(bS) )
  CopyMemory( gapsCopy(), temp_gapsCopy(), (xPrevious+1)*SizeOf(Long) )

Debug "--new()"
d(xPrevious)
d(x)
Debug "------"

  Dim bCopy.bS(x,y)
  Dim gapsCopy.l(x)

  i=0
  While ( i <= x ) And ( (bCopy_i1+i) <= xPrevious ) And ( (bCopy_i1+i) <= bCopy_i2 )
    For k=0 To y
      bCopy(i,k)\toggled = temp_bCopy(bCopy_i1+i,k)\toggled
      ;bCopy(i,k)\pos..
      ;bCopy(i,k)\pos..
      bCopy(i,k)\joinR = temp_bCopy(bCopy_i1+i,k)\joinR
      bCopy(i,k)\joinL = temp_bCopy(bCopy_i1+i,k)\joinL
      gapsCopy(i) = temp_gapsCopy(bCopy_i1+i)
    Next
    i+1
  Wend
  bCopy_i1 = 0
  bCopy_i2 = i-1
  ;+++++++++++++++


  selectedArea_on=0
  SetToolBarButtonState(#Toolbar,#ButtSelection,selectedArea_on)
  selectedArea_i1=0
  selectedArea_i2=x
  selectedArea_x1=b(0,0)\pos\x -1
  selectedArea_x2=b(x,0)\pos\x +bw -1
  posVer.d=0.0
  posHor.d=0.5

  redraw(#redraw_main)
  
  SetWindowTitle(#winMain, "       byhp - F1:help"+" - "+"untitled" )
EndProcedure


Procedure save()
  Protected tempByte.b
  Protected k_write.l
  
  savefile=SaveFileRequester( "save file", savefile, "*.byhp|*.byhp", 0 )
  If Not savefile
    ProcedureReturn
  EndIf
  If GetExtensionPart(savefile)<>"byhp"
    savefile+".byhp"
  EndIf
  If ReadFile(0,savefile)
    CloseFile(0)
    If MessageRequester("please confirm", "'"+savefile+"'"+#CRLF$+" already exists."+#CRLF$+"replace file?", #PB_MessageRequester_YesNo ) = #PB_MessageRequester_No
      ProcedureReturn
    EndIf
  EndIf
  
  If CreateFile(0,savefile)
    version$=Space(32)
    PokeS(@version$, "byhp-file : ver 0.1", 31)
    WriteData(0, @version$, 32)
    WriteLong(0, x )
    WriteLong(0, y )
    WriteLong(0, duration )
; + Write Bars?
    first=-1
    For i=0 To x
      For k=0 To y
        If first=-1 And b(i,k)\toggled
          first=i
        EndIf
        If b(i,k)\toggled
          last=i
        EndIf
      Next
    Next
    WriteLong(0, first )
    WriteLong(0, last )
    
    ;DATA
    
    For i=0 To x
      tempByte=gaps(i)
      WriteByte(0, tempByte )
    Next
    
    If first > -1

      For i=first To last
        k_write = -1
        For k=0 To y
          If b(i,k)\toggled
            k_write=k
            Break
          EndIf
        Next
        tempByte = k_write
        WriteByte(0, tempByte)
        If k_write > -1
          tempByte=b(i,k_write)\toggled
          WriteByte(0, tempByte)
          
          tempByte=b(i,k_write)\joinR
          WriteByte(0, tempByte)
          
          tempByte=b(i,k_write)\joinL
          WriteByte(0, tempByte)
        EndIf
      Next

    EndIf
    
    CloseFile(0)
    SetWindowTitle(#winMain, "       byhp"+" - "+savefile )
  Else
    MessageRequester("invalid file", "can't create "+#CRLF$+#CRLF$+"'"+savefile+"'" )
  EndIf
EndProcedure









Procedure load(mode=0)
  Protected tempByte.b
  Protected k_read.l

  If mode=1
    loadfile=ProgramParameter(0)
  Else
    loadfile=OpenFileRequester( "load file", loadfile, "*.byhp|*.byhp|*.*|*.*", 0 )
  EndIf
  
  If ReadFile(0,loadfile)
    version$=ReadString(0)
    Select version$
      Case "byhp-file : ver 0.1"
        FileSeek(0,32)
        xPrevious.l=x
        x=ReadLong(0)
        y=ReadLong(0)
        duration=ReadLong(0)
        first=ReadLong(0)
        last=ReadLong(0)
        
        ;DATA
        
        Dim gaps.l(x)
        For i=0 To x
          tempByte=ReadByte(0)
          gaps(i)=tempByte
        Next
        
        Dim b.bS(x,y)
        If first > -1
    
          For i=first To last
            tempByte=ReadByte(0)
            k_read=tempByte
            If k_read > -1
              tempByte = ReadByte(0)
              b(i,k_read)\toggled = tempByte
              
              tempByte = ReadByte(0)
              b(i,k_read)\joinR = tempByte
              
              tempByte = ReadByte(0)
              b(i,k_read)\joinL = tempByte
            EndIf
          Next
    
        EndIf
        
        
        ReadData(0, b(), (x+1)*(y+1)*SizeOf(bS) )
        ReadData(0, gaps(), (x+1)*SizeOf(Long) )
      Default
        MessageRequester("invalid file", "invalid file-format:"+#CRLF$+#CRLF$+"'"+loadfile+"'" )
        If mode=1
          End
        EndIf
    EndSelect
    CloseFile(0)
    
    SetGadgetState(#GaSpTempo, duration)
    
    ;+++++++++++++++ make copy-data compatible
    Protected Dim temp_bCopy.bS(xPrevious,y)
    Protected Dim temp_gapsCopy.l(xPrevious)
    CopyMemory( bCopy(), temp_bCopy(), (xPrevious+1)*(y+1)*SizeOf(bS) )
    CopyMemory( gapsCopy(), temp_gapsCopy(), (xPrevious+1)*SizeOf(Long) )
  
Debug "--load()"
d(xPrevious)
d(x)
Debug "------"
  
    Dim bCopy.bS(x,y)
    Dim gapsCopy.l(x)
  
    i=0
    While ( i <= x ) And ( (bCopy_i1+i) <= xPrevious ) And ( (bCopy_i1+i) <= bCopy_i2 )
      For k=0 To y
        bCopy(i,k)\toggled = temp_bCopy(bCopy_i1+i,k)\toggled
        ;bCopy(i,k)\pos..
        ;bCopy(i,k)\pos..
        bCopy(i,k)\joinR = temp_bCopy(bCopy_i1+i,k)\joinR
        bCopy(i,k)\joinL = temp_bCopy(bCopy_i1+i,k)\joinL
        gapsCopy(i) = temp_gapsCopy(bCopy_i1+i)
      Next
      i+1
    Wend
    bCopy_i1 = 0
    bCopy_i2 = i-1
    ;+++++++++++++++
  
; ;     Dim bCopy.bS(x,y)
; ;     Dim gapsCopy.l(x)
    
    getButtonPostions()
    gapsSum=b(x,0)\pos\x-x*bw-5
    posVer.d=0.0
    posHor.d=0.5
    
    selectedArea_on=0
    SetToolBarButtonState(#Toolbar,#ButtSelection,selectedArea_on)
    selectedArea_i1=0
    selectedArea_i2=x
    selectedArea_x1=b(0,0)\pos\x -1
    selectedArea_x2=b(x,0)\pos\x +bw -1
    
    redraw(#redraw_main)
    SetWindowTitle(#winMain, "       byhp"+" - "+loadfile )
    savefile=loadfile
  ElseIf loadfile
    MessageRequester("invalid file", "can't load "+#CRLF$+#CRLF$+"'"+loadfile+"'" )
    If mode=1
      End
    EndIf
  EndIf
EndProcedure








; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 499
; FirstLine = 468
; Folding = ---
; Markers = 451,591
; UseMainFile = byhp_main.pb