; debugging macro
Macro M_quote
  "
EndMacro
Macro d(_exp)
  Debug M_quote _exp : M_quote + Str(_exp)
EndMacro
;----------


Enumeration
  #winMain
    #GaSpTempo
    #GaImgVer
    #GaImgHor
    #GaImg00
    #Toolbar
    #space1
    #space2
    #space3
    #ButtSing
    #ButtShut
    #ButtLoop
    #ButtCode
    #ButtNew
    #ButtLoad
    #ButtSave
    #ButtSelection
    #ButtCopy
    #ButtPaste
    #Key_Space
    #Key_F1Help
    #Key_R
    #Key_S
    #ButtDelete
    
  #winCode
    #GaEdCode
    #ButtCopyCode
    
  #winNew
    #newButtApply
    #newButtCancel
    #newTextWidth
    #newSpWidth
    #newTextSmall
    #newSpSmall
    #newTextLarge
    #newSpLarge
    
  #popupMenu
    #ppm_cancel
    #ppm_deleteColumn
    #ppm_insertColumn

  #popupMenuPaste
    #ppmp_cancel
    #ppmp_layout
    #ppmp_notes
    #ppmp_both
EndEnumeration


; flags/modes for procedure sing():
#sing_sing=2
#sing_code=4
; flags/modes for procedure redraw():
#redraw_ver=2
#redraw_hor=4
#redraw_main=8
#redraw_main_leftClick=16
#redraw_main_rightClick=32


Structure bS
  toggled.l
  pos.POINT
  joinR.l
  joinL.l
EndStructure

oktaven=9 -1
baseOkt=3
Global smallBar.l=4                ;by default 4 buttons are one small bar
Global largeBar.l=4                ;by default 4 small bars are one large bar (16 buttons)
Global x=smallBar*largeBar *32 -1  ;<<<<<<<<<<< MAX X VALUE OF ARRAYS ECT
Global y=12*oktaven -1             ;<<<<<<<<<<< MAX Y ...
; Debug "x="+Str(x)
; Debug "y="+Str(y)
; Debug ""
Global xPrevious.l=x         ;needed in proc new() after change of x-width
Global Dim b.bS(x,y)         ;<< VALUES OF EACH BUTTON <<
;Global Dim bPos.Point(x,y)   ;<< pixel coordinates of each button [..obsolete]

Global Dim gaps.l(x)           ;<< gaps(i) contains the vertical left-right gap between b(i,k) and b(i-1,k)
Global gapsSum=0             ;<< all gaps added
Global duration.l=120        ;<< duration of a beeb-atom
Global NewList code.s()
Structure beepS
  frequency.l
  mute.l
  duration.l
EndStructure
Global NewList beep.beepS()


; tune the base octave (octave 3)
Global Dim h0.f(11)
h0(0)=264
h0(1)=h0(0)*16/15
h0(2)=297
h0(3)=h0(2)*16/15
h0(4)=330
h0(5)=352
h0(6)=h0(5)*16/15
h0(7)=396
h0(8)=h0(7)*16/15
h0(9)=440
h0(10)=h0(9)*16/15
h0(11)=495
; and derive the other notes
Global Dim h.f(y)
For i=0 To y
  h(i)= h0(i%12) * Pow(2,Int(i/12)-baseOkt)
Next



Global mx   ;<<WindowMouseX()
Global my   ;<<WindowMouseY()
Global mxOld
Global myOld
; Global mxDT   ;<<DesktopMouseX()
; Global myDT   ;<<DesktopMouseY()
; Global mxDTOld
; Global myDTOld
Global mxD  ;<<Delta-WindowMouseX
Global myD  ;<<Delta-WindowMouseY

Global mouseImgX ;<<mouse x-coord. in editor
Global mouseImgY ;<<mouse y-coord. in editor
Global mouseIndexOld.POINT
Global mouseIndexNew.POINT
Global dragJoinIndexStart=-1
Global dragJoinIndexEnd


If Not GetPathPart(ProgramFilename()) = #PB_Compiler_Home+"Compilers\"
  SetCurrentDirectory( GetPathPart(ProgramFilename()) )
EndIf
;MessageRequester("", GetCurrentDirectory())

Global img01=LoadImage(#PB_Any,"Data\img01.bmp") ;<<button standard
If Not img01 : MessageRequester("error","can't load Data\img01.bmp") : End : EndIf
Global img02=LoadImage(#PB_Any,"Data\img02.bmp") ;<<button toggled
If Not img02 : MessageRequester("error","can't load Data\img02.bmp") : End : EndIf
Global img02_L=LoadImage(#PB_Any,"Data\img02_L.bmp")
If Not img02_L : MessageRequester("error","can't load Data\img02_L.bmp") : End : EndIf
Global img02_LR=LoadImage(#PB_Any,"Data\img02_LR.bmp")
If Not img02_LR : MessageRequester("error","can't load Data\img02_LR.bmp") : End : EndIf
Global img02_R=LoadImage(#PB_Any,"Data\img02_R.bmp") ;<<button toggled
If Not img02_R : MessageRequester("error","can't load Data\img02_R.bmp") : End : EndIf
Global img01hnd=ImageID(img01)
Global img02hnd=ImageID(img02)
Global img02_Lhnd=ImageID(img02_L)
Global img02_LRhnd=ImageID(img02_LR)
Global img02_Rhnd=ImageID(img02_R)
Global bw=ImageWidth(img01)+1  ;<<button-width plus a default-border
Global bh=ImageHeight(img01)+1 ;<<button-height plus a default-border

Structure PanelS ;<<metrics for graphical gadgets
  x.l
  y.l
  w.l
  h.l
  img.l
EndStructure
Global ver.PanelS ;<< vertical scroll-bar
Global hor.PanelS ;<< horizontical scroll-bar
Global main.PanelS ;<< main editor area

Global posVer.d=0.0 ;<< current vertical scroll-position, 0.0=left, 1.0=right
Global posHor.d=0.5 ;<< current horizontical scroll-position, 0.0=top, 1.0=bottom
Global verDrag
Global horDrag

Global selectedArea_on     ;<< wether the selection is active or not
Global selectedArea_i1     ;<< index start
Global selectedArea_i2     ;<< index last
Global selectedArea_x1     ;<< pixel start
Global selectedArea_x2     ;<< pixel last
Global Dim bCopy.bS(x,y)   ;<< array-copy of Dim b(x,y) for the selection/copy
Global Dim gapsCopy.l(x)   ;<< array-copy of Dim gaps(x) for the selection/copy
Global bCopy_i1            ;<< index start in Dim bCopy(x,y)
Global bCopy_i2            ;<< index lastt in Dim bCopy(x,y)


;toolbar-icons
new  =LoadImage(#PB_Any, "Data\new.ico"  ) :: If Not new  : MessageRequester("error","can't load Data\new.ico")  : End : EndIf
space=LoadImage(#PB_Any, "Data\space.ico") :: If Not space: MessageRequester("error","can't load Data\space.ico"): End : EndIf
sing =LoadImage(#PB_Any, "Data\sing.ico" ) :: If Not sing : MessageRequester("error","can't load Data\sing.ico") : End : EndIf
shut =LoadImage(#PB_Any, "Data\shut.ico" ) :: If Not shut : MessageRequester("error","can't load Data\shut.ico") : End : EndIf
loop =LoadImage(#PB_Any, "Data\loop.ico" ) :: If Not loop : MessageRequester("error","can't load Data\loop.ico") : End : EndIf
code =LoadImage(#PB_Any, "Data\code.ico" ) :: If Not code : MessageRequester("error","can't load Data\code.ico") : End : EndIf
load =LoadImage(#PB_Any, "Data\load.ico" ) :: If Not load : MessageRequester("error","can't load Data\load.ico") : End : EndIf
save =LoadImage(#PB_Any, "Data\save.ico" ) :: If Not save : MessageRequester("error","can't load Data\save.ico") : End : EndIf
copy =LoadImage(#PB_Any, "Data\copy.ico" ) :: If Not copy : MessageRequester("error","can't load Data\copy.ico") : End : EndIf
paste=LoadImage(#PB_Any, "Data\paste.ico" ):: If Not paste: MessageRequester("error","can't load Data\paste.ico"): End : EndIf
selec=LoadImage(#PB_Any, "Data\selec.ico" ):: If Not selec: MessageRequester("error","can't load Data\selec.ico"): End : EndIf

Global savefile.s=GetCurrentDirectory()
Global loadfile.s=GetCurrentDirectory()


Global hWin          ; main window handle
Global quit          ; exit program 
Global shutUp        ; exit sing proc
Global ppm_i         ; i-index of popupmenu position
Global showMouseMenu ; show mouse menu 1
Global pasteWhat     ; flag for paste
Global play_thread_ID; the thread-ID for procedure thread_play()
Global beep_thread_ID; the thread-ID for procedure thread_beep()
Global beep_thread_freq
Global beep_thread_dura
Global playAsLoop    ; repeat mode toggle

Global moveView      ; boolean-flag for moving the view with mouse / ..for Alt-Key
; Global posVer_old.f
; Global posHor_old.f
; Global moveX
; Global moveY
; Global moveStartX
; Global moveStartY






; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 90
; FirstLine = 68
; Folding = -
; UseMainFile = byhp_main.pb
; HideErrorLog